; Z88 FORTH V3.00
; SALVADOR MERINO
; Avda. Torreblanca 5
; 29640 FUENGIROLA (MALAGA)
RETURN EQU 48128
LBEND  EQU 47744
LENGTH EQU 128
LBADD  EQU 47616
IPADD  EQU 47488
;
       ORG 10000
       LD HL,0
       ADD HL,SP
       LD (BSLK),HL
       LD SP,(#1FFE)
       LD HL,0
       ADD HL,SP
       LD (STACK),HL
       CALL START
       LD SP,(BSLK)
       RET
;
BSLK   DEFW 0
STACK  DEFW 0
;
VMODE  DEFW 0
VSTATE DEFW 0
VDP    DEFW DICCI
VCONTE DEFW VCORE
VCURRE DEFW $+2
       DEFW EX188
VLBP   DEFW 0
VBASE  DEFW 0
VCORE  DEFW EX188
VCOMPI DEFW IN22
;
;
; INNER INTERPRETER
;
;
SEMI   DEFW $+2
       LD C,(IY+0)
       INC IY
       LD B,(IY+0)
       INC IY
NEXT   LD A,(BC)
       LD L,A
       INC BC
       LD A,(BC)
       LD H,A
       INC BC
RUN    LD E,(HL)        
       INC HL
       LD D,(HL)
       INC HL  
       EX DE,HL 
       JP (HL)
COLON  DEC IY
       LD (IY+0),B
       DEC IY
       LD (IY+0),C
       LD C,E 
       LD B,D
       JP (IX)
EX1    DEFB 7
       DEFM "EXE"
       DEFW 0
EXECUT DEFW $+2
       POP HL
       JR RUN
;
;
;
OUTER  DEFW TAIPI
       DEFW INLINE
       DEFW ASPACE
       DEFW TOKEN
       DEFW SEAR?
       DEFW PORIF
       DEFB 11  
       DEFW NU_BER
       DEFW POREND
       DEFB 243 
       DEFW QUESTI
       DEFW PORWHI
       DEFB 234
       DEFW EXECU?
       DEFW PORWHI
       DEFB 233 
;
;
SEAR?  DEFW COLON
       DEFW CONTEX
       DEFW COPYRI
       DEFW COPYRI
       DEFW SEARCH
       DEFW DUP
       DEFW PORIF
       DEFB 32
       DEFW MODE
       DEFW CCOPIR
       DEFW PORIF
       DEFB 25  
       DEFW DROP
       DEFW COMPIL
       DEFW COPYRI
       DEFW SEARCH 
       DEFW DUP
       DEFW PORIF
       DEFB 6
       DEFW CERO
       DEFW PORELS
       DEFB 3       
       DEFW UNO
       DEFW STATE
       DEFW CADM
       DEFW SEMI
;
;
EXECU? DEFW COLON
       DEFW STATE
       DEFW CCOPIR
       DEFW STATE 
       DEFW C0SET
       DEFW MODE
       DEFW CCOPIR
       DEFW IGUAL
       DEFW PORIF
       DEFB 8
       DEFW EXECUT
       DEFW STACK_
       DEFW PORELS
       DEFB 3
       DEFW COMA
       DEFW SEMI
;
;
NU_BER DEFW COLON
       DEFW NUMBER
       DEFW PORIF
       DEFB 37
       DEFW MODE
       DEFW CCOPIR
       DEFW PORIF
       DEFB 25
       DEFW SINGLE
       DEFW PORIF
       DEFB 12
       DEFW PORIGU
       DEFW PORIGU
       DEFW COMA
       DEFW COMA
       DEFW PORELS
       DEFB 9
       DEFW PORIGU
       DEFW PORCIG
       DEFW COMA
       DEFW CCOMA
       DEFW CERO
       DEFW PORELS
       DEFB 3
       DEFW UNO
       DEFW SEMI
;
CERO   DEFW $+2
       LD HL,0
       PUSH HL
       JP (IX)
;
UNO    DEFW $+2
       LD HL,1
       PUSH HL
       JP (IX)
;
START  LD DE,RSTMSG
       LD A,(VBASE)
       AND A
       JR NZ,ABORT
       LD A,10
       LD (VBASE),A
       LD DE,SRTMSG
ABORT  LD SP,(STACK)
       PUSH DE
       LD HL,0
       LD (VMODE),HL
       LD IX,NEXT
       LD IY,RETURN
       LD HL,#8080
       LD (LBEND),HL
       LD BC,OUTER
       JP NEXT
;
SRTMSG DEFB 88
       DEFB 12
       DEFM "ZFORTH v3.00"
       DEFB 13
       DEFB 10
       DEFM "SALVADOR MERINO,"
       DEFM " Avda. Torreblanca 5,"
       DEFM " 29640 FUENGIROLA,"
       DEFM " MALAGA "
       DEFM " (SPAIN)"
       DEFB 13
       DEFB 10
RSTMSG DEFB 10
       DEFM " ABORT !"
       DEFB 13
       DEFB 10
;
;
INLINE DEFW $+2
       PUSH BC
COMIEN CALL CR_LF
INLIN3 LD HL,LBADD
       LD (VLBP),HL
       LD B,LENGTH
CLEAR0 LD (HL),32
       INC HL
       DJNZ CLEAR0
ZERO   LD L,0
INKEY  CALL KEY_
       CP 0
       JR Z,INKEY
       CP 27
       JR Z,INKEY
       CP 127
       JR NZ,TSTCR
       DEC L
       JP M,ZERO
       LD (HL),32
       LD A,8
ISSUE  CALL ECHO_
       JR INKEY
TSTCR  CP 13
       JR Z,LAST1
       BIT 7,L
       JR NZ,ENDI
SAVEIT LD (HL),A
       CP #61
       JR C,NOTLC
       CP #7B
       JR NC,NOTLC
       RES 5,(HL)
NOTLC  INC L
       JR ISSUE
ENDI   DEC L
       LD C,A
       LD A,8
       CALL ECHO_
       LD A,C
       JR SAVEIT
LAST1  LD A,32
       CALL ECHO_
       POP BC
       LD IX,NEXT
       JP (IX)
;
       DEFW TOKEN
       DEFW EX1
EX2    DEFB 5
       DEFM "TOKEN"
TOKEN  DEFW $+2
       EXX
       LD HL,(VLBP)
       LD DE,(VDP)
       POP BC
       LD A,32
       CP C
       JR NZ,TOK
IGNLB  CP (HL)
       JR NZ,TOK
       INC L 
       JR IGNLB
TOK    PUSH HL       
COUNT  INC B
       INC L
       LD A,(HL)
       CP C
       JR Z,ENDTOK 
       RLA
       JR NC,COUNT
       DEC L
ENDTOK INC L 
       LD (VLBP),HL
       LD A,B
       LD (DE),A
       INC DE
       POP HL
       LD C,B
       LD B,0
       LDIR
       EXX
       JP (IX)
;
;
       DEFW SEARCH
       DEFW EX2
EX3    DEFB 6
       DEFM "SEARCH"
SEARCH DEFW $+2
       EXX  
       POP HL
TESTIT PUSH HL       
       LD DE,(VDP)
       LD C,0
       LD A,(DE) 
       CP (HL)
       JR NZ,NXTHDR
       LD B,A
NXTCH  INC HL
       INC DE
       LD A,(DE)
       CP (HL)
       JR NZ,NXTHDR
       DJNZ NXTCH
       POP HL
       DEC HL
       DEC HL
       DEC HL
       LD D,(HL)
       DEC HL
       LD E,(HL)
       PUSH DE
       JR FLAG
NXTHDR POP HL
       DEC HL
       LD D,(HL)
       DEC HL
       LD E,(HL)
       EX DE,HL
       LD A,H
       OR L
       JR NZ,TESTIT
       LD C,1 
FLAG   PUSH BC   
       EXX 
       JP (IX)
;
;
NUMBER DEFW $+2
       EXX 
       LD HL,(VDP)
       LD B,(HL) 
       INC HL 
NUM_   LD A,(HL)
       CP 45
       LD A,0
       JR NZ,SKIPSA
       DEC A
       DEC B
       INC HL
SKIPSA EX AF,AF'
       LD DE,0
       PUSH DE
       PUSH DE
NLOOP  LD A,(HL)
       SUB 48
       JR C,NOTNO
       CP 10
       JR C,NUMB
       CP 17
       JR C,NOTNO 
       SUB 7
NUMB   LD E,A       
       LD A,(VBASE)
       DEC A
       CP E
       JR NC,ANUMB 
NOTNO  POP HL         
       EXX
       JP (IX)
ANUMB  EX (SP),HL
       EX DE,HL
       PUSH BC
       PUSH HL
       LD BC,2048
       INC A
       LD L,C
       LD H,C
MLOOP  ADD HL,HL       
       ADC A,A
       JR NC,SKPADD
       ADD HL,DE
SKPADD DJNZ MLOOP       
       POP DE 
       ADD HL,DE 
       POP BC
       EX (SP),HL
       INC HL
       DJNZ NLOOP
       POP DE
       POP HL
       EX AF,AF'
       AND A
       JR Z,DONE
       SBC HL,DE
       EX DE,HL
DONE   PUSH DE       
       SCF
       PUSH AF
       EXX
       JP (IX)
;
;
QUESTI DEFW $+2
       LD HL,(VDP)
       INC HL
       BIT 7,(HL)
       JR Z,ERROR
       LD DE,OK
       PUSH DE
       JP (IX)
ERROR  CALL CR_LF
       LD IX,RETUR2
       DEC HL
       JP TYPE_
RETUR2 LD DE,MSG?
       JP PATCH_
;
;
OK     DEFB 3
       DEFM " OK"
MSG?   DEFB 2
       DEFM " ?"
;
;
STACK_ DEFW $+2
       LD HL,(STACK)
       AND A
       SBC HL,SP
       JR NC,OKPLUS
       ADD HL,SP
       LD SP,HL
       LD DE,STKMSG
       JP PATCH_
OKPLUS JP (IX)
;
;
STKMSG DEFB 14
       DEFM " STACK ERROR"
       DEFB 13
       DEFB 10
;
;
PATCH_ LD A,(VMODE)
       AND A
       JP Z,ABORT 
       PUSH DE
       LD HL,(VCURRE)
       LD E,(HL)
       INC HL
       LD D,(HL)
       EX DE,HL
       LD (VDP),HL
       LD A,5
       ADD A,L 
       LD L,A
       JR NC,SKIP
       INC H
SKIP   LD A,(HL)
       LD (DE),A
       DEC HL
       DEC DE
       LD A,(HL)
       LD (DE),A
       POP DE
       JP ABORT
;
;
       DEFW PLUSLO
       DEFW EX1
IN1    DEFB 5
       DEFM "+LOOP"
PLUSLO DEFW COLON
       DEFW PORIGU
       DEFW PORMLO
       DEFW ENDCOM
       DEFW SEMI
;
       DEFW BEGIN
       DEFW IN1
IN2    DEFB 5   
       DEFM "BEGIN"
BEGIN  DEFW COLON
       DEFW HERE
       DEFW SEMI 
;
       DEFW CMALOO
       DEFW IN2
IN3    DEFB 6
       DEFM "C+LOOP"
       DEFW IN2 
CMALOO DEFW COLON
       DEFW PORIGU
       DEFW CMLOOP
       DEFW ENDCOM
       DEFW SEMI
;
       DEFW CDO
       DEFW IN3
IN4    DEFB 3
       DEFM "CDO"
CDO    DEFW COLON
       DEFW PORIGU
       DEFW PORCDO
       DEFW DOCOMA
       DEFW SEMI
;
       DEFW CLEAVE
       DEFW IN4
IN5    DEFB 6
       DEFM "CLEAVE"
       DEFW IN4
CLEAVE DEFW COLON
       DEFW PORIGU
       DEFW PORCLE
       DEFW COMA
       DEFW SEMI
;
       DEFW CLOOP
       DEFW IN5
IN6    DEFB 5
       DEFM "CLOOP"
       DEFW IN5 
CLOOP  DEFW COLON       
       DEFW PORIGU
       DEFW PORCLO
       DEFW ENDCOM
       DEFW SEMI
;
       DEFW DO
       DEFW IN6
IN7    DEFB 2
       DEFM "DO"
DO     DEFW COLON
       DEFW PORIGU
       DEFW PORDO
       DEFW DOCOMA
       DEFW SEMI 
;
       DEFW ELSE
       DEFW IN7
IN8    DEFB 4
       DEFM "ELSE"
ELSE   DEFW COLON       
       DEFW PORIGU
       DEFW PORELS
       DEFW DOCOMA
       DEFW CERO
       DEFW CCOMA
       DEFW SWAP
       DEFW THEN
       DEFW SEMI
;
       DEFW END
       DEFW IN8
IN9    DEFB 3
       DEFM "END"
END    DEFW COLON       
       DEFW PORIGU
       DEFW POREND
       DEFW ENDCOM
       DEFW SEMI
;
       DEFW IF
       DEFW IN9
IN10   DEFB 2
       DEFM "IF"
IF     DEFW COLON 
       DEFW PORIGU
       DEFW PORIF
       DEFW DOCOMA
       DEFW CERO
       DEFW CCOMA
       DEFW SEMI
;
       DEFW LEAVE
       DEFW IN10
IN11   DEFB 5
       DEFM "LEAVE"
LEAVE  DEFW COLON
       DEFW PORIGU
       DEFW PORLEA
       DEFW COMA
       DEFW SEMI
;
       DEFW LOOP
       DEFW IN11
IN12   DEFB 4 
       DEFM "LOOP"
LOOP   DEFW COLON
       DEFW PORIGU
       DEFW PORLOO
       DEFW ENDCOM
       DEFW SEMI
;
       DEFW THEN
       DEFW IN12
IN13   DEFB 4       
       DEFM "THEN"
THEN   DEFW COLON    
       DEFW HERE
       DEFW OVER
       DEFW MENOS
       DEFW SWAP
       DEFW CADM
       DEFW SEMI
;
       DEFW WHILE
       DEFW IN13
IN14   DEFB 5
       DEFM "WHILE"
WHILE  DEFW COLON       
       DEFW SWAP
       DEFW PORIGU
       DEFW PORWHI
       DEFW ENDCOM
       DEFW THEN
       DEFW SEMI
;
       DEFW CORCH1
       DEFW IN14
IN15   DEFB 2
       DEFM "."
       DEFB 34
CORCH1 DEFW COLON
       DEFW PORIGU
       DEFW PORCOR
       DEFW COMA
       DEFW PORCIG
       DEFB 34
       DEFW TOKEN 
       DEFW HERE
       DEFW CCOPIR
       DEFW UNOMAS
       DEFW DP
       DEFW MASADM
       DEFW SEMI
;
       DEFW PCOMA
       DEFW IN15
IN16   DEFB 1
       DEFB 59
PCOMA  DEFW COLON
       DEFW PORIGU
       DEFW SEMI
       DEFW COMA
       DEFW MODE
       DEFW C0SET
       DEFW SEMI
;
       DEFW PCCODE
       DEFW IN16
IN17   DEFB 5
       DEFB 59
       DEFM "CODE"
PCCODE DEFW COLON
       DEFW PORIGU
       DEFW SCODE
       DEFW COMA
       DEFW MODE
       DEFW C0SET
       DEFW SEMI
;
       DEFW ADMI_2
       DEFW EX3
EX4    DEFB 1
       DEFM "!"
ADMI_2 DEFW $+2
       POP HL
       POP DE
       LD (HL),E
       INC HL
       LD (HL),D
       JP (IX)
;
       DEFW IGU_RA
       DEFW EX4
EX5    DEFB 1
       DEFM "#"
IGU_RA DEFW COLON
       DEFW CERO
       DEFW BASE
       DEFW CCOPIR
       DEFW DDIVMO
       DEFW ASCII
       DEFW SWAP
       DEFW SEMI
;
       DEFW IGU_MA
       DEFW EX5
EX6    DEFB 2
       DEFM "#>"
IGU_MA DEFW $+2
       INC IY
       JP DISPL_
;
       DEFW IGU_S
       DEFW EX6
EX7    DEFB 2
       DEFM "#S"
IGU_S  DEFW COLON
       DEFW IGU_RA
       DEFW DUP
       DEFW CEROIG
       DEFW POREND
       DEFB 248
       DEFW DROP 
       DEFW SEMI
;
CR_LF  RST #20
       DEFB #09
       DEFB #2E
       RET
;
ECHO_  RST #20
       DEFB #27
       RET
;
KEY_   RST #20
       DEFB #2A
       JR C,KEY_
       RET
;    
ISIGN_ LD A,D
       XOR B
       EX AF,AF'
       LD A,D
       AND A
       JP P,TST2
       LD HL,0
       SBC HL,DE
       EX DE,HL
TST2   LD H,B  
       LD L,C
       LD A,B
       AND A
       RET P
       LD HL,0
       SBC HL,BC
       RET
;
SIGN_0 EX AF,AF'
       RET P
       EX DE,HL
       LD HL,0
       SBC HL,DE
       RET
;
UDPOR  LD A,L
       LD BC,2048
       LD H,C
       LD L,C
DPORLO ADD HL,HL
       ADC A,A
       JR NC,SKADD
       ADD HL,DE
       ADC A,C
SKADD  DJNZ DPORLO
       LD C,A
       RET
;
US_POR LD H,L
       LD L,0
       LD D,L
       LD B,8
SPORLO ADD HL,HL
       JR NC,SKPAD
       ADD HL,DE
SKPAD  DJNZ SPORLO
       RET
;
UDDIV  LD B,16
DDIVLO ADD HL,HL
       LD A,D
       ADC A,D
       LD D,A 
       SUB E
       JP M,SKIP2
       INC L
       LD D,A
SKIP2  DJNZ DDIVLO
       LD C,D
       RET
;
USDIV  LD B,8
SDIVLO ADD HL,HL
       LD A,H
       SUB E
       JP M,SKP 
       INC L
       LD H,A
SKP    DJNZ SDIVLO
       LD C,H
       LD H,B
       RET  
;
       DEFW COMILL
       DEFW EX7
EX8    DEFB 1
       DEFM "'"
COMILL DEFW COLON
       DEFW ASPACE
       DEFW TOKEN
       DEFW CONTEX
       DEFW COPYRI
       DEFW COPYRI
       DEFW SEARCH
       DEFW PORIF
       DEFB 10
       DEFW ENTRY
       DEFW SEARCH
       DEFW PORIF
       DEFB 3
       DEFW QUESTI
       DEFW SEMI
;
       DEFW POR
       DEFW EX8
EX9    DEFB 1
       DEFM "*"
POR    DEFW $+2
       EXX
       POP BC
       POP DE
       CALL ISIGN_
       CALL UDPOR
       CALL SIGN_0
       PUSH HL 
       EXX
       JP (IX)
;
PORIGU DEFW $+2
       LD A,(BC)
       LD E,A
       INC BC
       LD A,(BC)
       LD D,A
       INC BC
       PUSH DE
       JP (IX)
;
PORMLO DEFW $+2
       PUSH IY
       POP HL 
       POP DE
       LD A,E
       JP LOO_OP
;
       DEFW PORDIV
       DEFW EX9
EX10   DEFB 2
       DEFM "*/"
PORDIV DEFW $+2
       LD IX,RETTO
       JP POD_MO
RETTO  POP HL        
       LD IX,NEXT
       JP (IX)
;
       DEFW PODIMO
       DEFW EX10
EX11   DEFB 5
       DEFM "*/M"
PODIMO DEFW $+2
POD_MO POP HL
       EXX
       POP BC
       POP DE
       CALL ISIGN_
       CALL UDPOR
       EXX
       EX AF,AF' 
       XOR L
       EX AF,AF'
       LD A,L
       EXX 
       AND A
       JP P,SKIPN
       NEG
SKIPN  LD D,C
       LD E,A
       CALL UDDIV
       CALL SIGN_0
       PUSH HL
       PUSH BC
       EXX
       JP (IX)
;
PORCIG DEFW $+2
       LD A,(BC)
       LD E,A
       INC BC
       RLA
       SBC A,A
       LD D,A
       PUSH DE
       JP (IX)
;
CMLOOP
       DEFW $+2
       PUSH IY
       POP HL
       POP DE
       LD A,(HL)
       ADD A,E
       LD (HL),A
       JP CLO_OP
;
PORCDO DEFW $+2
       POP HL
       LD (IY-2),L
       POP HL  
       LD (IY-1),L
       DEC IY
       DEC IY
       JP (IX)
;
PORCLE
       DEFW $+2
       LD A,(IY+1)
       LD (IY+0),A
       JP (IX)
;
PORCLO DEFW $+2
       PUSH IY
       POP HL
       INC (HL)
CLO_OP LD A,(HL)
       INC HL
       SUB (HL)
       JP C,WH_LE
       INC IY
       INC IY
       INC BC
       JP (IX)
;
PORDO  DEFW $+2
       POP HL
       LD (IY-4),L
       LD (IY-3),H
       POP HL
       LD (IY-2),L
       LD (IY-1),H
       LD DE,-4
       ADD IY,DE
       JP (IX)
;
PORELS DEFW $+2
ELSE_  LD A,(BC)
       ADD A,C
       LD C,A
       JR NC,OUT
       INC B
OUT    JP (IX)
;
POREND DEFW $+2
       POP HL
       LD A,L
       OR H
       JP Z,WH_LE
       INC BC
       JP (IX)
;
PORIF  DEFW $+2
       POP HL
       LD A,L
       OR H
       JP Z,ELSE_
       INC BC
       JP (IX)
;
PORLEA DEFW $+2
       LD A,(IY+3)
       LD (IY+1),A
       LD A,(IY+2)
       LD (IY+0),A
       JP (IX)
;
PORLOO DEFW $+2
       PUSH IY
       POP HL  
       LD A,1
LOO_OP ADD A,(HL)
       LD (HL),A 
       INC HL
       JR NC,PAGE
       INC (HL) 
PAGE   LD D,(HL) 
       INC HL
       SUB (HL)
       LD A,D
       INC HL
       SBC A,(HL)
       JP C,WH_LE
       LD DE,4
       ADD IY,DE
       INC BC
       JP (IX)
;
PORWHI DEFW $+2
WH_LE  LD A,(BC)
       ADD A,C
       LD C,A
       JR C,OUT10
       DEC B
OUT10  JP (IX)
;
PORCOR DEFW $+2
       LD A,(BC)
       LD D,A
SLOOP  INC BC 
       LD A,(BC)
       CALL ECHO_
       DEC D 
       JR NZ,SLOOP
       INC BC
       JP (IX)
;
       DEFW PLUS
       DEFW EX11
EX12   DEFB 1
       DEFM "+"
PLUS   DEFW $+2
       POP HL
       POP DE  
       ADD HL,DE
       PUSH HL
       JP (IX)
;
       DEFW MASADM
       DEFW EX12
EX13   DEFB 2
       DEFM "+!"
MASADM DEFW $+2
       POP HL
       POP DE
       LD A,(HL)
       ADD A,E
       LD (HL),A
       INC HL
       LD A,(HL)
       ADC A,D
       LD (HL),A
       JP (IX)
;
       DEFW PLSP
       DEFW EX13
EX14   DEFB 3
       DEFM "+SP"  
PLSP   DEFW $+2
       POP HL
       ADD HL,SP
       PUSH HL
       JP (IX)
;
       DEFW COMA
       DEFW EX14
EX15   DEFB 1
       DEFM ","
COMA   DEFW $+2
       POP DE
       LD HL,(VDP)
       LD (HL),E
       INC HL
       LD (HL),D
       INC HL
       LD (VDP),HL
       JP (IX)
;

       DEFW MENOS
       DEFW EX15
EX16   DEFB 1
       DEFM "-"
MENOS  DEFW $+2
       POP DE
       POP HL
       AND A
       SBC HL,DE
       PUSH HL
       JP (IX)
;
       DEFW MENSP
       DEFW EX16
EX17   DEFB 3
       DEFM "-SP" 
MENSP  DEFW $+2
       POP HL
       AND A
       SBC HL,SP
       PUSH HL
       JP (IX)
;
       DEFW PUNTO
       DEFW EX17
EX18   DEFB 1 
       DEFM ".  "
PUNTO  DEFW COLON
       DEFW MENIGU
       DEFW ABS
       DEFW IGU_S
       DEFW SIGN
       DEFW IGU_MA
       DEFW SEMI 
;
       DEFW DIVIDI
       DEFW EX18
EX19   DEFB 1
       DEFM "/"
DIVIDI DEFW $+2
       EXX
       POP DE
       POP BC
       CALL ISIGN_
       CALL USDIV
       CALL SIGN_0
       PUSH HL
       EXX
       JP (IX)
;
       DEFW DIVIMD
       DEFW EX19
EX20   DEFB 4
       DEFM "/MO"
DIVIMD DEFW $+2
       EXX
       POP DE      
       POP BC
       CALL ISIGN_
       CALL USDIV
       CALL SIGN_0
       PUSH HL
       PUSH BC 
       EXX
       JP (IX)
;
       DEFW CEROME
       DEFW EX20
EX21   DEFB 2
       DEFM "0<"
CEROME DEFW $+2
       POP AF
       LD DE,0
       RLA
       JR NC,PUSHI2
       INC E 
PUSHI2 PUSH DE
       JP (IX)
;
       DEFW CEROIG
       DEFW EX21
EX22   DEFB 2
       DEFM "0="
CEROIG DEFW $+2
       POP HL
       LD A,L
       OR H
       LD DE,0
       JR NZ,OUT3
       INC DE
OUT3   PUSH DE
       JP (IX)
;
       DEFW CERSET
       DEFW EX22
EX23   DEFB 4
       DEFM "0SET"
CERSET DEFW $+2
       POP HL
       XOR A
       LD (HL),A
       INC HL
       LD (HL),A
       JP (IX)
;
       DEFW UNOMAS
       DEFW EX23
EX24   DEFB 2
       DEFM "1+"
UNOMAS DEFW $+2
       POP HL
       INC HL
       PUSH HL
       JP (IX)
;
       DEFW UNOMEN
       DEFW EX24
EX25   DEFB 2
       DEFM "1-"
UNOMEN DEFW $+2
       POP HL
       DEC HL
       PUSH HL
       JP (IX)
;
       DEFW UNOSET
       DEFW EX25
EX26   DEFB 4
       DEFM "1SET"
UNOSET DEFW $+2
       POP HL
       LD (HL),1
       INC HL
       LD (HL),0
       JP (IX)
;
       DEFW DOSPOR
       DEFW EX26
EX27   DEFB 2
       DEFM "2*"
DOSPOR DEFW $+2
       POP HL
       ADD HL,HL
       PUSH HL
       JP (IX)
;
       DEFW DOSMAS
       DEFW EX27
EX28   DEFB 2
       DEFM "2+"
DOSMAS DEFW $+2
       POP HL
       INC HL
       INC HL
       PUSH HL
       JP (IX)
;
       DEFW DOSMEN
       DEFW EX28
EX29   DEFB 2
       DEFM "2-"
DOSMEN DEFW $+2
       POP HL
       DEC HL
       DEC HL
       PUSH HL
       JP (IX)
;
       DEFW DOSDIV
       DEFW EX29
EX30   DEFB 2
       DEFM "2/"
DOSDIV DEFW $+2
       POP HL
       SRA H
       RR L
       PUSH HL
       JP (IX)
;
       DEFW DDUP
       DEFW EX30
EX31   DEFB 4
       DEFM "2DUP"
DDUP   DEFW $+2
       POP HL
       PUSH HL
       PUSH HL
       PUSH HL
       JP (IX)
;
       DEFW DOVER
       DEFW EX31
EX32   DEFB 5
       DEFM "2OVER"
DOVER  DEFW $+2
       EXX
       POP HL
       POP DE
       POP BC
       PUSH BC
       PUSH DE
       PUSH HL
       PUSH BC 
       EXX
       JP (IX)
;
       DEFW DSWAP
       DEFW EX32
EX33   DEFB 5
       DEFM "2SWAP"
DSWAP  DEFW $+2
       POP HL
       POP DE
       EX (SP),HL
       PUSH DE
       PUSH HL
       JP (IX)
;
       DEFW DOLST
       DEFW EX33
EX34   DEFB 1
       DEFM ":"
DOLST  DEFW COLON
       DEFW CURREN
       DEFW COPYRI
       DEFW CONTEX
       DEFW ADMI_2
       DEFW CREATE 
       DEFW PORIGU
       DEFW COLON
       DEFW CAADM
       DEFW MODE
       DEFW C1SET
       DEFW SEMI
;
       DEFW MENQUE
       DEFW EX34
EX35   DEFB 1
       DEFM "<"
MENQUE DEFW $+2
       POP DE
       POP HL
       AND A
       SBC HL,DE
       LD DE,0
       JP P,PUSHIT
       INC E
PUSHIT PUSH DE
       JP (IX)
;
       DEFW MENIGU
       DEFW EX35
EX36   DEFB 2
       DEFM "<#"
MENIGU DEFW $+2
       POP HL
       LD E,160  
       PUSH DE
       PUSH HL
       DEC IY
       LD (IY+0),H
       JP (IX)
;
       DEFW BUILDS
       DEFW EX36
EX37   DEFB 7 
       DEFM "<BUILDS"
BUILDS DEFW COLON
       DEFW CERO
       DEFW CONSTA
       DEFW SEMI
;
       DEFW MENR
       DEFW EX37
EX38   DEFB 2
       DEFM ">R "
MENR   DEFW $+2
       POP HL
       DEC IY
       LD (IY+0),H
       DEC IY
       LD (IY+0),L
       JP (IX)
;
       DEFW IGUAL
       DEFW EX38
EX39   DEFB 1 
       DEFM "="
IGUAL  DEFW $+2
       POP HL
       POP DE   
       AND A
       SBC HL,DE 
       LD DE,0
       JR NZ,PUSIT2
       INC E
PUSIT2 PUSH DE
       JP (IX)
;
       DEFW MAYOR
       DEFW EX39
EX40   DEFB 1
       DEFM ">"
MAYOR  DEFW $+2
       POP HL
       POP DE
       AND A
       SBC HL,DE
       LD DE,0 
       JP P,PUSIT3
       INC E
PUSIT3 PUSH DE
       JP (IX)
;
       DEFW INTERR
       DEFW EX40
EX41   DEFB 1
       DEFM "?"
INTERR DEFW COLON
       DEFW COPYRI
       DEFW PUNTO
       DEFW SEMI
;
       DEFW INTRM
       DEFW EX41
EX42   DEFB 3
       DEFM "?R>"
INTRM  DEFW $+2
       PUSH IY
       JP (IX)
;
       DEFW INTSP
       DEFW EX42
EX43   DEFB 3 
       DEFM "?SP" 
INTSP  DEFW $+2
       LD HL,0
       ADD HL,SP
       EX DE,HL
       LD HL,(STACK)
       AND A
       SBC HL,DE
       JR NC,SKIP4
       LD SP,(STACK)
SKIP4  PUSH DE
       JP (IX)
;
       DEFW COPYRI
       DEFW EX43
EX44   DEFB 1
       DEFM "@"
COPYRI DEFW $+2
       POP HL
       LD E,(HL)
       INC HL
       LD D,(HL)
       PUSH DE
       JP (IX)
;
       DEFW ABO
       DEFW EX44
EX45   DEFB 5
       DEFM "ABORT"
ABO    DEFW $+2
       JP START
;
       DEFW ABS
       DEFW EX45
EX46   DEFB 3
       DEFM "ABS" 
ABS    DEFW $+2
       POP DE
       BIT 7,D
       JR Z,OUT4
       LD HL,0
       AND A
       SBC HL,DE
       EX DE,HL       
OUT4   PUSH DE
       JP (IX)
;
       DEFW LOAD
       DEFW EX46
EX47   DEFB 5
       DEFM "*CLI"
       DEFB 34
LOAD   DEFW COLON
       DEFW PORCIG
       DEFB 34
       DEFW TOKEN
       DEFW HERE
       DEFW DDUP
       DEFW CCOPIR
       DEFW UNOMAS
       DEFW PLUS
       DEFW CERO
       DEFW SWAP
       DEFW CADM
       DEFW CLI_
       DEFW SEMI
;
CLI_   DEFW $+2
       POP HL
       PUSH BC
       LD C,(HL)
       INC HL
       LD B,0
       RST #20
       DEFB #0C
       DEFB #14
       POP BC
       JP (IX)
;
       DEFW AND
       DEFW EX47
EX48   DEFB 3
       DEFM "AND"
AND    DEFW $+2
       POP HL
       POP DE
       LD A,L
       AND E
       LD L,A
       LD A,H
       AND D
       LD H,A
       PUSH HL
       JP (IX)
;
       DEFW APART
       DEFW EX48
EX49   DEFB 5
       DEFM "APART"
APART  DEFW COLON
       DEFW SPACE
       DEFW PORCIG
       DEFB 8
       DEFW CERO
       DEFW PORCDO
       DEFW DUP
       DEFW CCOPIR
       DEFW PORCIG
       DEFB 128
       DEFW OR
       DEFW ECHO
       DEFW SPACE
       DEFW UNOMAS
       DEFW PORCLO
       DEFB 239
       DEFW SEMI
;
       DEFW ASCII
       DEFW EX49
EX50   DEFB 5
       DEFM "ASCII"
       DEFW EX49
ASCII  DEFW $+2
       POP HL
       LD A,48
       ADD A,L
       CP 58
       JR C,OUT5
       ADD A,7
OUT5   LD L,A
       PUSH HL
       JP (IX)
;
       DEFW ASPACE
       DEFW EX50
EX51   DEFB 6
       DEFM "ASPACE"
ASPACE DEFW $+2
       LD HL,32
       PUSH HL
       JP (IX)
;
       DEFW BINARY
       DEFW EX51
EX52   DEFB 6
       DEFM "BINARY"
BINARY DEFW $+2
       LD A,2 
       LD (VBASE),A
       JP (IX)
;
       DEFW CPADM
       DEFW EX52
EX53   DEFB 3
       DEFM "C+!"
CPADM  DEFW $+2
       POP HL
       POP DE
       LD A,(HL)
       ADD A,E
       LD (HL),A
       JP (IX)
;
       DEFW CCOMA
       DEFW EX53
EX54   DEFB 2
       DEFM "C,"
CCOMA  DEFW $+2
       POP DE
       LD HL,(VDP)
       LD (HL),E
       INC HL
       LD (VDP),HL
       JP (IX)
;
       DEFW C0SET
       DEFW EX54
EX55   DEFB 5
       DEFM "C0SET"
C0SET  DEFW $+2
       POP HL
       LD (HL),0
       JP (IX)
;
       DEFW C1SET
       DEFW EX55
EX56   DEFB 5
       DEFM "C1SET"
C1SET  DEFW $+2
       POP HL
       LD (HL),1
       JP (IX)
;
       DEFW CMNR
       DEFW EX56
EX57   DEFB 3
       DEFM "C<R"
CMNR   DEFW $+2
       POP HL
       DEC IY
       LD (IY+0),L
       JP (IX)
;
       DEFW CINT
       DEFW EX57
EX58   DEFB 2
       DEFM "C?"
CINT   DEFW COLON
       DEFW CCOPIR
       DEFW PUNTO
       DEFW SEMI
;
       DEFW CCOPIR
       DEFW EX58
EX59   DEFB 2  
       DEFM "C@"
CCOPIR DEFW $+2
       POP HL
       LD E,(HL) 
       LD A,E
       RLA
       SBC A,A
       LD D,A
       PUSH DE
       JP (IX)
;
       DEFW CAADM
       DEFW EX59
EX60   DEFB 3 
       DEFM "CA!"
CAADM  DEFW COLON
       DEFW ENTRY
       DEFW DUP
       DEFW CCOPIR
       DEFW UNOMAS
       DEFW PLUS
       DEFW ADMI_2
       DEFW SEMI
;
       DEFW CCONST
       DEFW EX60
EX61   DEFB 9 
       DEFM "CCONSTANT"
CCONST DEFW COLON
       DEFW CREATE
       DEFW CCOMA
       DEFW SCODE
       LD A,(DE)
       LD L,A
       RLA
       SBC A,A
       LD H,A
       PUSH HL
       JP (IX)
;
       DEFW CIMAY
       DEFW EX61
EX62   DEFB 3
       DEFM "CI>"
CIMAY  DEFW $+2
       LD L,(IY+0)
       LD A,L
       RLA
       SBC A,A
       LD H,A
       PUSH HL
       JP (IX)
;
       DEFW CJMAY
       DEFW EX62
EX63   DEFB 3
       DEFM "CJ>"
CJMAY  DEFW $+2
       LD L,(IY+2)
       LD A,L
       RLA
       SBC A,A
       LD H,A
       PUSH HL
       JP (IX)
;
       DEFW CJOIN
       DEFW EX63
EX64   DEFB 5
       DEFM "CJOIN"
CJOIN  DEFW $+2
       POP HL
       POP DE
       LD D,L
       PUSH DE
       JP (IX)
;
       DEFW CKMAY
       DEFW EX64
EX65   DEFB 3
       DEFM "CK>"
CKMAY  DEFW $+2
       LD L,(IY+4)
       LD A,L
       RLA
       SBC A,A
       LD H,A
       PUSH HL
       JP (IX)
;
       DEFW CLEAR
       DEFW EX65
EX66   DEFB 5 
       DEFM "CLEAR"
CLEAR  DEFW $+2
       LD A,12
       CALL ECHO_
       JP (IX)
;
       DEFW CONSTA
       DEFW EX66
EX67   DEFB 8
       DEFM "CONSTANT"
CONSTA DEFW COLON
       DEFW CREATE
       DEFW COMA
       DEFW SCODE
       EX DE,HL
       LD E,(HL)
       INC HL
       LD D,(HL)
       PUSH DE
       JP (IX)
;
       DEFW CRMAY
       DEFW EX67
EX68   DEFB 3
       DEFM "CR>" 
CRMAY  DEFW $+2
       LD L,(IY+0)
       INC IY
       LD H,0
       BIT 7,L
       JR Z,SKIP_4
       DEC H 
SKIP_4 PUSH HL
       JP (IX)
;
       DEFW CREATE
       DEFW EX68
EX69   DEFB 6
       DEFM "CREATE"
CREATE DEFW COLON
       DEFW PORIGU
       DEFW 0
       DEFW COMA
       DEFW ENTRY
       DEFW COMA
       DEFW ASPACE
       DEFW TOKEN
       DEFW HERE
       DEFW CURREN
       DEFW COPYRI
       DEFW ADMI_2
       DEFW HERE
       DEFW CCOPIR
       DEFW UNOMAS
       DEFW DP
       DEFW MASADM
       DEFW HERE
       DEFW ENTRY
       DEFW PORIGU
       DEFW 4
       DEFW MENOS
       DEFW ADMI_2
       DEFW HERE
       DEFW DOSMAS
       DEFW COMA
       DEFW SEMI
;
       DEFW CRET
       DEFW EX69
EX70   DEFB 2
       DEFM "CR"
CRET   DEFW $+2
       CALL CR_LF
       JP (IX)
;
       DEFW CSPLIT
       DEFW EX70
EX71   DEFB 6 
       DEFM "CSPLIT"
CSPLIT DEFW $+2
       POP HL
       LD E,H
       LD H,0
       LD D,H
       BIT 7,E
       JR Z,OUT1
       DEC D
OUT1   PUSH DE 
       PUSH HL
       JP (IX)
;
       DEFW CVA
       DEFW EX71
EX72   DEFB 9
       DEFM "CVARIABLE"
CVA    DEFW COLON
       DEFW CCONST
       DEFW SCODE 
       PUSH DE
       JP (IX)
;
       DEFW DPOR
       DEFW EX72
EX73   DEFB 2
       DEFM "D*"
DPOR   DEFW $+2
       EXX
       POP BC
       POP DE
       CALL ISIGN_
       CALL UDPOR
       EX AF,AF'
       JP P,OUTPOR
       LD A,C
       CPL
       LD C,A
       EX DE,HL 
       LD HL,0
       SBC HL,DE
       JR NZ,OUTPOR
       INC C
OUTPOR PUSH HL
       PUSH BC
       EXX
       JP (IX)
;

       DEFW DDIVMO
       DEFW EX73
EX74   DEFB 5
       DEFM "D/M"
DDIVMO DEFW $+2
       EXX
       POP HL
       POP DE
       POP BC
       LD A,H
       XOR D
       EX AF,AF'
       LD A,L
       AND A
       JP P,MOV1
       NEG
MOV1   LD D,A
       LD H,B
       LD L,C
       LD A,E
       LD E,D
       AND A
       JP P,MOV2
       CPL
       LD HL,0
       SBC HL,BC
       JP NZ,MOV2
       INC A
MOV2   LD D,A
       CALL UDDIV
       CALL SIGN_0
       PUSH HL
       PUSH BC
       EXX
       JP (IX)
;
       DEFW DECI
       DEFW EX74
EX75   DEFB 7
       DEFM "DECIMAL"
DECI   DEFW $+2
       LD A,10
       LD (VBASE),A
       JP (IX)
;
       DEFW DEFI
       DEFW EX75
EX76   DEFB 11
       DEFM "DEFINITIONS"
DEFI   DEFW $+2
       LD HL,(VCONTE)
       LD (VCURRE),HL
       JP (IX)
;

       DEFW DISP
       DEFW EX76
EX77   DEFB 7
       DEFM "DISPLAY"
DISP   DEFW $+2
DISPL_ POP HL
       LD A,L
       CP #A0
       JR Z,FI_DIS
       CALL ECHO_
       JR DISPL_
FI_DIS LD A,32
       CALL ECHO_
       JP (IX)
;
       DEFW DOCOMA
       DEFW EX77
EX78   DEFB 3
       DEFM "DO,"
DOCOMA DEFW COLON
       DEFW COMA
       DEFW HERE
       DEFW SEMI
;
       DEFW DOESMA
       DEFW EX78
EX79   DEFB 5
       DEFM "DOES>"
DOESMA DEFW COLON
       DEFW RMAYOR
       DEFW ENTRY
       DEFW DUP
       DEFW CCOPIR
       DEFW UNOMAS
       DEFW DOSMAS
       DEFW PLUS
       DEFW ADMI_2
       DEFW SCODE
       DEC IY
       LD (IY+0),B
       DEC IY
       LD (IY+0),C
       EX DE,HL 
       LD C,(HL)
       INC HL
       LD B,(HL)
       INC HL
       PUSH HL 
       JP (IX)
;
       DEFW DROP
       DEFW EX79
EX80   DEFB 4 
       DEFM "DROP"
DROP   DEFW $+2
       POP HL
       JP (IX)
;
       DEFW PUNTOJ
       DEFW EX80
EX81   DEFB 2
       DEFM ".J"
PUNTOJ DEFW $+2
       JP (IX)
;
       DEFW DUP
       DEFW EX81
EX82   DEFB 3
       DEFM "DUP"
DUP    DEFW $+2
       POP HL
       PUSH HL
       PUSH HL
       JP (IX)
;
       DEFW ECHO
       DEFW EX82
EX83   DEFB 4
       DEFM "EMIT"
ECHO   DEFW $+2
       POP HL
       LD A,L
       CALL ECHO_
       JP (IX)
;
       DEFW ENDCOM
       DEFW EX83
EX84   DEFB 4
       DEFM "END,"
ENDCOM DEFW COLON
       DEFW COMA
       DEFW HERE
       DEFW MENOS
       DEFW CCOMA
       DEFW SEMI
;
       DEFW ENTRY
       DEFW EX84
EX85   DEFB 5
       DEFM "ENTRY"
ENTRY  DEFW COLON 
       DEFW CURREN
       DEFW COPYRI
       DEFW COPYRI
       DEFW SEMI
;
       DEFW ERASE
       DEFW EX85
EX86   DEFB 5
       DEFM "ERASE"
ERASE  DEFW COLON 
       DEFW UNOMAS
       DEFW SWAP  
       DEFW PORDO
       DEFW ASPACE
       DEFW IMAYOR
       DEFW CADM
       DEFW PORLOO
       DEFB 248
       DEFW SEMI
;
       DEFW FILL
       DEFW EX86
EX87   DEFB 4
       DEFM "FILL"
FILL   DEFW COLON
       DEFW UNOMAS
       DEFW SWAP
       DEFW PORDO
       DEFW DUP
       DEFW IMAYOR
       DEFW CADM
       DEFW PORLOO
       DEFB 248
       DEFW DROP
       DEFW SEMI
;
       DEFW FORGET
       DEFW EX87
EX88   DEFB 6
       DEFM "FORGET"
FORGET DEFW COLON 
       DEFW CURREN
       DEFW COPYRI
       DEFW CONTEX
       DEFW ADMI_2
       DEFW COMILL
       DEFW DUP
       DEFW PORCIG
       DEFB 2
       DEFW MENOS
       DEFW COPYRI
       DEFW CURREN
       DEFW COPYRI
       DEFW ADMI_2
       DEFW PORCIG
       DEFB 6 
       DEFW MENOS
       DEFW DP
       DEFW ADMI_2
       DEFW SEMI 
;
       DEFW HERE
       DEFW EX88
EX89   DEFB 4
       DEFM "HERE"
HERE   DEFW $+2
       LD HL,(VDP)
       PUSH HL
       JP (IX)
;
       DEFW HEX
       DEFW EX89
EX90   DEFB 3
       DEFM "HEX" 
HEX    DEFW $+2
       LD A,16
       LD (VBASE),A
       JP (IX)
;
       DEFW IMAYOR
       DEFW EX90
EX91   DEFB 2
       DEFM "I>"
IMAYOR DEFW $+2
       LD L,(IX+0)
       LD H,(IX+1)
       PUSH HL 
       JP (IX)
;
       DEFW IMMDIA
       DEFW EX91
EX92   DEFB 9 
       DEFM "IMMEDIATE"
IMMDIA DEFW COLON
       DEFW ENTRY
       DEFW DUP
       DEFW DOSMEN
       DEFW DUP
       DEFW COPYRI
       DEFW CURREN
       DEFW COPYRI
       DEFW ADMI_2
       DEFW COMPIL
       DEFW COPYRI
       DEFW SWAP
       DEFW ADMI_2
       DEFW COMPIL
       DEFW ADMI_2
       DEFW SEMI
;
       DEFW IOR
       DEFW EX92
EX93   DEFB 3
       DEFM "IOR"
IOR    DEFW $+2
       POP HL
       POP DE
       LD A,L
       OR E
       LD L,A
       LD A,H
       OR D
       LD H,A
       PUSH HL
       JP (IX)
;
       DEFW JMAY
       DEFW EX93
EX94   DEFB 2
       DEFM "J>"
JMAY   DEFW $+2
       LD L,(IY+4)
       LD H,(IY+5)
       PUSH HL
       JP (IX)
;
       DEFW KMAY
       DEFW EX94
EX95   DEFB 2
       DEFM "K>"
KMAY   DEFW $+2
       LD L,(IY+8)
       LD H,(IY+9)
       PUSH HL
       JP (IX)
;
       DEFW KEY
       DEFW EX95
EX96   DEFB 3
       DEFM "KEY"
KEY    DEFW $+2
       CALL KEY_
       LD L,A
       PUSH HL
       JP (IX)
;
       DEFW LROT
       DEFW EX96
EX97   DEFB 4
       DEFM "LROT"
LROT   DEFW $+2
       POP DE
       POP HL
       EX (SP),HL
       PUSH DE
       PUSH HL
       JP (IX)
;
       DEFW MAX
       DEFW EX97
EX98   DEFB 3 
       DEFM "MAX"
MAX    DEFW $+2
       POP DE
       POP HL
       PUSH HL
       AND A
       SBC HL,DE
       JP P,OUT8
       POP HL
       PUSH DE
OUT8   JP (IX)
;
       DEFW MIN
       DEFW EX98
EX99   DEFB 3
       DEFM "MIN"
MIN    DEFW $+2
       POP DE
       POP HL
       AND A
       SBC HL,DE
       JP NC,OUT9
       POP HL
       PUSH DE
OUT9   JP (IX)
;
       DEFW MINUS
       DEFW EX99
EX100  DEFB 5
       DEFM "MINUS"
MINUS  DEFW $+2
       LD HL,0
       POP DE
       AND A
       SBC HL,DE
       PUSH HL
       JP (IX)
;
       DEFW MOD
       DEFW EX100
EX101  DEFB 3
       DEFM "MOD"
MOD    DEFW $+2
       EXX
       POP DE
       POP BC
       CALL ISIGN_
       CALL USDIV
       PUSH BC
       EXX
       JP (IX)
;
       DEFW MODUD
       DEFW EX101
EX102  DEFB 5
       DEFM "MODU/"
MODUD  DEFW $+2
       EXX
       POP DE
       POP BC
       CALL ISIGN_
       CALL USDIV
       CALL SIGN_0
       PUSH BC
       PUSH HL
       EXX
       JP (IX)
;
       DEFW MOVE
       DEFW EX102
EX103  DEFB 4
       DEFM "MOVE"
MOVE   DEFW $+2
       EXX
       POP DE
       POP HL
       POP BC
       AND A
       SBC HL,BC
       PUSH BC
       EX (SP),HL
       POP BC
       EX DE,HL
       PUSH HL
       AND A
       SBC HL,DE  
       POP HL
       JR NC,BOTTOM
       EX DE,HL
       INC BC
       LDIR
OUTM   EXX 
       JP (IX)
BOTTOM ADD HL,BC
       EX DE,HL
       ADD HL,BC
       INC BC
       LDDR 
       JR OUTM
;
       DEFW NNEXT
       DEFW EX103
EX104  DEFB 4
       DEFM "NEXT"
NNEXT  DEFW COLON
       DEFW PORIGU
       DEFW #E9DD
       DEFW COMA
       DEFW SEMI
;
       DEFW NOT
       DEFW EX104
EX105  DEFB 3
       DEFM "NOT"
NOT    DEFW $+2
       POP HL
       LD A,L
       OR H
       LD DE,0
       JR NZ,OUT12
       INC E
OUT12  PUSH DE
       JP (IX)
;
       DEFW OCTAL
       DEFW EX105
EX106  DEFB 5
       DEFM "OCTAL"
OCTAL  DEFW $+2
       LD A,8
       LD (VBASE),A
       JP (IX)
;
       DEFW OVER
       DEFW EX106
EX107  DEFB 4
       DEFM "OVER"
OVER   DEFW $+2
       POP HL
       POP DE
       PUSH DE
       PUSH HL
       PUSH DE
       JP (IX)
;
       DEFW OR
       DEFW EX107
EX108  DEFB 2
       DEFM "OR"
OR     DEFW $+2
       POP HL
       POP DE
       LD A,L
       OR E
       LD L,A
       LD A,H
       OR D
       LD H,A
       PUSH HL
       JP (IX)
;
       DEFW RMAYOR
       DEFW EX108
EX109  DEFB 2
       DEFM "R>"
RMAYOR DEFW $+2
       LD L,(IY+0)
       INC IY
       LD H,(IY+0)
       INC IY
       PUSH HL
       JP (IX)
;
       DEFW RROT
       DEFW EX109
EX110  DEFB 4
       DEFM "RROT"
RROT   DEFW $+2
       POP HL
       POP DE
       EX (SP),HL
       PUSH HL
       PUSH DE
       JP (IX)
;
       DEFW SPOR
       DEFW EX110
EX111  DEFB 2 
       DEFM "S*"
SPOR   DEFW $+2
       EXX
       POP BC
       POP DE
       CALL ISIGN_
       CALL US_POR
       CALL SIGN_0
       PUSH HL
       EXX
       JP (IX)
;
       DEFW SCODE
       DEFW EX111
EX112  DEFB 5
       DEFM "SCO" 
SCODE  DEFW COLON 
       DEFW RMAYOR
       DEFW CAADM
       DEFW SEMI
;
       DEFW SIGN
       DEFW EX112
EX113  DEFB 4
       DEFM "SIGN"
SIGN   DEFW $+2
       BIT 7,(IY+0)
       JR Z,OUT11
       LD L,#2D
       PUSH HL
OUT11  JP (IX)
;
       DEFW SINGLE
       DEFW EX113
EX114  DEFB 6
       DEFM "SINGLE"
SINGLE DEFW $+2
       POP HL
       PUSH HL 
       LD L,H
       LD A,H
       AND A
       JR Z,OUT_12
       INC HL
OUT_12 PUSH HL
       JP (IX)
;
       DEFW SPACE
       DEFW EX114
EX115  DEFB 5
       DEFM "SPACE"
       DEFW EX114
SPACE  DEFW $+2
       LD A,32
       CALL ECHO_
       JP (IX)
;
       DEFW SWAP
       DEFW EX115
EX116  DEFB 4 
       DEFM "SWAP"
SWAP   DEFW $+2
       POP HL
       EX (SP),HL
       PUSH HL
       JP (IX)
;
       DEFW TAIPI
       DEFW EX116
EX117  DEFB 4
       DEFM "TYPE"
TAIPI  DEFW $+2
       POP HL
TYPE_  LD E,(HL)
LOOP4  INC HL
       LD A,(HL)
       CALL ECHO_
       DEC E
       JR NZ,LOOP4
       JP (IX)
;
       DEFW VAR
       DEFW EX117
EX118  DEFB 8
       DEFM "VARIABLE"
VAR    DEFW COLON
       DEFW CONSTA
       DEFW SCODE
       PUSH DE 
       JP (IX)
;
       DEFW VOC
       DEFW EX118
EX119  DEFB 10
       DEFM "VOCABULARY"
VOC    DEFW COLON
       DEFW BUILDS
       DEFW ENTRY
       DEFW COMA
       DEFW DOESMA
       DEFW CONTEX
       DEFW ADMI_2
       DEFW SEMI 
;
       DEFW WAIT
       DEFW EX119
EX120  DEFB 4
       DEFM "WAIT"
WAIT   DEFW $+2
       RST #20
       DEFB #7E
       JP (IX)
;
       DEFW XOR
       DEFW EX120
EX121  DEFB 3
       DEFM "XOR" 
XOR    DEFW $+2
       POP HL
       POP DE
       LD A,L
       XOR E
       LD L,A
       LD A,H
       XOR D
       LD H,A
       PUSH HL   
       JP (IX)
;
       DEFW MODE
       DEFW EX121
EX123  DEFB 4
       DEFM "MODE"
MODE   DEFW $+2
       LD HL,VMODE
       PUSH HL
       JP (IX)
;
       DEFW STATE
       DEFW EX123
EX124  DEFB 5
       DEFM "STATE"
STATE  DEFW $+2
       LD HL,VSTATE
       PUSH HL
       JP (IX)
;
       DEFW DP
       DEFW EX124
EX125  DEFB 2
       DEFM "DP"
DP     DEFW $+2
       LD HL,VDP
       PUSH HL
       JP (IX)
;
       DEFW CONTEX
       DEFW EX125
EX126  DEFB 7
       DEFM "CONTEXT"
CONTEX DEFW $+2
       LD HL,VCONTE
       PUSH HL
       JP (IX)
;
       DEFW CURREN
       DEFW EX126
EX127  DEFB 7
       DEFM "CURRENT"
CURREN DEFW $+2
       LD HL,VCURRE
       PUSH HL
       JP (IX)
;
       DEFW LBP
       DEFW EX127
EX128  DEFB 3
       DEFM "LBP"
LBP    DEFW $+2
       LD HL,VLBP
       PUSH HL
       JP (IX)
;
       DEFW BASE
       DEFW EX128
EX129  DEFB 4
       DEFM "BASE"
BASE   DEFW $+2
       LD HL,VBASE
       PUSH HL
       JP (IX)
;
       DEFW NUM
       DEFW EX129
EX130  DEFB 6
       DEFM "NUMBER"
NUM    DEFW COLON
       DEFW INLIN2
       DEFW ASPACE
       DEFW TOKEN
       DEFW NUMBER
       DEFW SEMI
;
INLIN2 DEFW $+2
       PUSH BC
       JP INLIN3
;
       DEFW BLEEP
       DEFW EX130
EX131  DEFB 5
       DEFM "BLEEP"
BLEEP  DEFW $+2
       POP HL
       LD A,L
       POP HL
       POP DE
       PUSH BC
       LD B,L
       LD C,E
       RST #20
       DEFB #06
       DEFB #D8
       POP BC
       JP (IX)
;
       DEFW CADM
       DEFW EX131
EX132  DEFB 2
       DEFM "C!"
CADM   DEFW $+2
       POP HL
       POP DE
       LD (HL),E
       JP (IX)
;
       DEFW COMPIL
       DEFW EX132
EX133  DEFB 8
       DEFM "COMPILER"
COMPIL DEFW $+2
       LD HL,VCOMPI
       PUSH HL
       JP (IX)
;
       DEFW COMP
       DEFW EX133
EX183  DEFB 7
       DEFM "COMPILE"
COMP   DEFW COLON
       DEFW MENR
       DEFW DUP
       DEFW DOSMAS
       DEFW RMAYOR
       DEFW COPYRI
       DEFW COMA
       DEFW SEMI
;
ERRM   LD DE,ERRMSG
       JP PATCH_
;
ERRMSG DEFB 11
       DEFM " ERROR ! "
       DEFB 13
       DEFB 10
;
       DEFW COMPC
       DEFW IN17
IN19   DEFB 9
       DEFM "[COMPILE]"
COMPC  DEFW COLON
       DEFW ASPACE
       DEFW TOKEN
       DEFW COMPILER
       DEFW COPYRI
       DEFW SEARCH
       DEFW DROP
       DEFW COMA
       DEFW SEMI
;
       DEFW LITE
       DEFW IN19
IN20   DEFB 7
       DEFM "LITERAL"
LITE   DEFW COLON
       DEFW PORIGU
       DEFW PORIGU
       DEFW COMA
       DEFW COMA
       DEFW SEMI
;
       DEFW CORCH
       DEFW IN20
IN21   DEFB 1
       DEFM "["
CORCH  DEFW $+2
       LD A,0
       LD (VMODE),A
       JP (IX)
;
       DEFW PARENT
       DEFW IN21
IN22   DEFB 1
       DEFM "("
PARENT DEFW COLON
       DEFW PORCIG
       DEFB 41
       DEFW TOKEN
       DEFW SEMI
;
       DEFW CIECOR
       DEFW EX183
EX184  DEFB 1
       DEFM "]"
CIECOR DEFW $+2
       LD A,1
       LD (VMODE),A
       JP (IX)
;
       DEFW BARRA
       DEFW EX184
EX185  DEFB 1
       DEFM "\"
BARRA  DEFW $+2
       LD BC,OUTER+2
       JP (IX)
;
       DEFW LIT
       DEFW EX185
EX186  DEFB 3
       DEFM "LIT"
LIT    DEFW COLON
       DEFW PORIGU
       DEFW PORIGU
       DEFW COMA
       DEFW COMA
       DEFW SEMI
;
SALONE DEFW COLON
       DEFW DROP
VALONE DEFW SEMI
       DEFW SEMI
;
FFNAME DEFM "ALONE.CDE"
       DEFB 0
;
       DEFW ALONE
       DEFW EX186
EX187  DEFB 5
       DEFM "ALONE"
ALONE  DEFW $+2
       POP HL
       PUSH BC
       PUSH IX
       LD (VALONE),HL
       LD HL,SALONE
       LD (OUTER),HL
       LD HL,FFNAME
       LD DE,(VDP)
       LD BC,20
       LD A,2
       RST #20
       DEFW #6009
       LD DE,10000
       LD HL,(VDP)
       AND A
       SBC HL,DE
       PUSH HL
       POP BC
       LD HL,10000
       LD DE,0
       RST #20
       DEFB #45
       RST #20
       DEFB #09
       DEFB #62
       POP IX
       POP BC
       JP (IX)
;
       DEFW FORTH
       DEFW EX187
EX188  DEFB 5
       DEFM "FORTH"
FORTH  DEFW $+2
       LD HL,VCORE
       LD (VCONTE),HL
       JP (IX)
;
DICCI  DEFW 0
;
